

CREATE TABLE spatial_test ( 
 id int identity primary key,
 geog geography,
 area as geog.STArea() PERSISTED,
 Lat as geog.Lat PERSISTED,
 Long as geog.Long PERSISTED
)

-- no problems here
select * from sys.dm_db_objects_impacted_on_version_change

CREATE TABLE spatial_test2 ( 
 id int identity primary key,
 geog1 geography,
 geog2 geography,
)

-- empty set in DMV
select * from sys.dm_db_objects_impacted_on_version_change

ALTER TABLE spatial_test2
ADD CONSTRAINT check_inter CHECK (geog1.STIntersects(geog2)=0)

-- persisted computed column
ALTER TABLE spatial_test2
ADD do_they_intersect AS geog1.STIntersects(geog2) PERSISTED

-- two rows now
select * from sys.dm_db_objects_impacted_on_version_change

-- this fails
ALTER TABLE spatial_test2
ADD whats_the_intersection AS geog1.STIntersection(geog2) PERSISTED
-- Msg 4994, Level 16, State 1, Line 1
-- Computed column 'whats_the_intersection' in table 'spatial_test2' cannot be persisted because the column type, 'geography', is a non-byte-ordered CLR type.

-- two rows now
select * from sys.dm_db_objects_impacted_on_version_change
