
use master
go

-- Create a master key in the master database, if you don't already have one
CREATE MASTER KEY ENCRYPTION BY PASSWORD =
    'Password1';

CREATE CERTIFICATE CertForAzureBackup
WITH SUBJECT = 'Backup Encryption Certificate';

-- Don't lose this password
-- You also need to create a credential a la Backup to URL:
CREATE CREDENTIAL myCredential
WITH IDENTITY = 'MyStorageAccountName',
SECRET = 'MyAccessKey';

-- The actual command to get the backups started:
EXEC msdb.smart_admin.sp_set_db_backup 
    @database_name = 'pubs',
    @retention_days = 10, 
	@credential_name = 'myCredential',
    @encryption_algorithm = 'AES_128', 
	@encryptor_type = 'Certificate',
    @Encryptor_name = 'CertForAzureBackup', 
	@enable_backup = 1;

-- Backup is running when you set @enable_backup to 1.

-- You can monitor backup events with sp_get_backup_diagnostics
DECLARE @eventresult TABLE
    (
     event_type NVARCHAR(512),
     event NVARCHAR(512),
     timestamp DATETIME
    )

INSERT  INTO @eventresult
EXEC msdb.smart_admin.sp_get_backup_diagnostics 
	@begin_time = '3/1/2014',
	@end_time = '3/31/2014';

SELECT  *
FROM    @eventresult
WHERE   event_type LIKE '%admin%';
